#include "pebblisp.h"

enum RouteType {
    GET,
    POST,
};

struct Route {
    const char* path;
    Object routeAction;
    struct Environment* env;
    enum RouteType type;
};

int addRoute(struct Route route);

int start(int port);

fn(startServer,
  "(serve) => 0\n"
  "Starts a simple web server with routes that have been added with (get) and (post).\n"
  "Note: This is a non-blocking call. It is recommended to wait for user input before exiting.\n"
  "  A simple way would be to use (inp) immediately after the (serve) call."
);

fn(addGetRoute,
  "Note: Implementation bugs currently prevent using an inline lambda.\n"
  "  (def homepage (fn () (\"Hello, world!\")));(get \"/\" homepage)\n"
  "  (def queryPage (fn (req) (req's queryParams)));(get \"/x\" queryPage)\n"
  "  (serve)\n"
);

fn(addPostRoute,
  "Note: Implementation bugs currently prevent using an inline lambda.\n"
  "  (def homepage (fn () (\"Hello, world!\")));(post \"/\" homepage)\n"
  "  (serve)\n"
);

